=== debian/changelog ===
codelite (16.0.0+dfsg2-3build1) lunar; urgency=medium

  * Rebuild against new wxwidgets 3.2.1+dfsg-3.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 18 Jan 2023 08:46:48 +0100

codelite (16.0.0+dfsg2-3) unstable; urgency=medium

  * QA upload.
  * Upload to unstable.

 -- Olly Betts <olly@survex.com>  Sun, 25 Sep 2022 09:53:47 +1300

codelite (16.0.0+dfsg2-2) experimental; urgency=medium

  * QA upload.
  * Build against the wxWidgets 3.2 (and the wxWidgets 3.2 build of wxSQLite).
    New patch: codelite-16.0.0+dfsg2/debian/patches/ (Closes: #1019796)

 -- Olly Betts <olly@survex.com>  Mon, 19 Sep 2022 16:07:32 +1200

codelite (16.0.0+dfsg2-1) unstable; urgency=medium

  * QA upload.
  * New upstream release.
  * Rebase patches and convert to gbp-pq.
  * Desktop file now includes the 'IDE' category. Closes: #923492
  * Repack source, Remove universal-ctags and tools/macOS
  * Drop patches:
    - 26_remove_hardcoded_x86.patch, included upstream
    - 28_spelling.patch, included upstream
    - 31_python3_upgrade.patch, included upstream
    - 32_hunspell_unnest_2_nested_classes.patch, included upstream
    - auto-gitignore, no longer needed.
  * New patch: 03_remove-bundled-universal-ctags.patch.
    Using already packaged universal-ctags instead.
  * Add forwarded not-needed, to 24_default_no_check_for_updates.patch.
  * Remove four library and binaries no longer shipped.
  * Drop dpkg-dev as build-dependency.
  * Remove old break/replace, no longer needed.
  * Update Standards-Version to 4.6.0.
  * Include new plugin in codelite-plugins:
    - Remoty
    - Rust
    - ctagsd
    - ctagsd-tests
  * Add file d/not-installed.
  * Bump debhelper to 13.
  * Add clangd, clang-format and universal-ctags to recommends
    in codelite-plugins.
  * Drop websocketpp-dev as recommends for codelite-plugins.
  * Fix spelling in previous changelog entry.
  * d/copyright:
    - Remove copyright entries for files that no longer exists.
    - Include entries for new files.
  * Update version restriction on cmake.
  * Drop version constraint on cppcheck.
  * Add lintian-override for 'python3-script-but-no-python3-dep'. Part of
    'Remoty' plugin. The mentioned script is sent to remote machine and,
    is therefore never executed on host.

 -- Håvard F. Aasen <havard.f.aasen@pfft.no>  Sat, 07 May 2022 22:47:01 +0200
