=== debian/changelog ===
codelite (17.0-1unofficial.jammy) jammy; urgency=low

  * Update for the 17.0 release

 -- David Hart <david@codelite.co.uk>  Sat, 07 Jan 2023 16:55:48 +0000

codelite (16.0-2) stable; urgency=low

  * d/control:
    - Add missing items to Build-Depends
    - Add libpcre2-32-0 to Depends as that version is forced by libgtk-3-dev
        but most buntu installs will have only 2-16

  * Update for the 16.0 release

 -- David Hart <david@codelite.co.uk>  Sat, 16 Apr 2022 10:18:05 +0100
